import requests
import json
import random
import time

def get_random_string(length):
    letters = "abcdefghijklmopqrstuvwxyz"
    result_str = ''.join(random.choice(letters) for i in range(length))
    return result_str


def get_token_from_real_user(real_email, real_password):
    print("getting your token data...")
    token_data = requests.post(
        "https://rethink.software/api/v2/tokens.create",
        json={"twoFactorAuthToken": "", "usersEmail": real_email, "usersPassword": real_password}
    )
    return token_data


def get_workspace_data(user_id, secret_token):
    print("getting user workspace data...")
    workspace_data = requests.get(
        "https://rethink.software/api/v2/workspacesUsers.read",
        params={"usersId": user_id},
        cookies={"token": secret_token}
    )
    return workspace_data


def generate_fake_emails_list(referrer_id, count):
    print("генерируем список фейковых адресов...")
    emails_list = []
    for x in range(count):
        # random_domain = get_random_string(6)
        random_email = get_random_string(5)
        emails_list.append({"email": f"{referrer_id[:5]}{random_email}{x}@1secmail.net"})
    return emails_list


def send_referrals_to_emails_list(emails_list, referrer_id, secret_token, workspace_id):
    print("рассылаем рефералки на каждый ящик...")
    # fake_emails_list = {"email": emails_list}
    created_refs = requests.post(
        "https://rethink.software/api/v2/referrals.create",
        json={"referrals": emails_list, "referrerId": referrer_id},
        cookies={"token": str(secret_token), "workspacesId": str(workspace_id)})
    return created_refs


def create_user(email_address):
    print('регаем ящик', email_address)
    try:
        create_user_request = requests.post(
            "https://rethink.software/api/v2/users.create",
            json={
                "name": "",
                "givenName": get_random_string(5),
                "familyName": get_random_string(5),
                "email": email_address,
                "password": "qweqwe321",
                "mobileSignupBounce": False,
                "timezone": "Europe/Moscow"
                })
        create_user_request.raise_for_status()
        return create_user_request
    except requests.exceptions.RequestException as e:
        print(f"пiзда рулю и седлу!: {e.response.text} - {email_address}")
        return None


def get_code_from_email(email):
    print('пиздим код из ящика', email)
    login = email.split("@")[0]
    verification_code_request = requests.get(
        "https://www.1secmail.com/api/v1/",
        params={
            "action": "getMessages",
            "login": login,
            "domain": "1secmail.net"})
    # verification_code_request.
    code = verification_code_request.json()[0]['subject'].split(" ")[-1]
    return code


def verify_user(email, code_from_email):
    user_verify_response = requests.post(
        "https://rethink.software/api/v2/users.verify",
        json={"email": email, "code": code_from_email})
    return user_verify_response


def complete_referral(fake_user_completed_id, fake_user_token, fake_email, referrer_id):
    print('завершаем рефералочку для', fake_email)
    complete_referral_data = requests.post(
        "https://rethink.software/api/v2/referrals.complete",
        json={"completedAccountId": fake_user_completed_id, "referrerId": referrer_id},
        cookies={"token": fake_user_token}
    )
    return complete_referral_data


def send_verify_code_to_email(fake_email):
    print('отправляем код подтверждения на ящик:', fake_email)
    request = requests.post(
        'https://rethink.software/api/v2/users.verify',
        json={"email": fake_email})
    return request


def main(real_user_email, real_user_password, count):
    token = get_token_from_real_user(real_user_email, real_user_password)
    secret_token = token.json()['data'][0]['secret']
    user_id = token.json()['data'][0]['user']['id']

    workspace_data = get_workspace_data(user_id, secret_token)
    referrer_id = workspace_data.json()['data'][0]['workspace']['referrerId']
    workspace_id = workspace_data.json()['data'][0]['workspace']['id']

    fake_emails_list = generate_fake_emails_list(referrer_id, count)

    send_referrals_to_emails_list(fake_emails_list, referrer_id, secret_token, workspace_id)

    print("ну а теперь регаем фейковых юзеров...")
    for fake_email in fake_emails_list:
        email = fake_email['email']
        fake_user_data = create_user(email)
        if fake_user_data:
            fake_user_id = fake_user_data.json()['data'][0]['id']
            fake_user_secret_token = fake_user_data.json()['data'][0]['token']['secret']

            send_verify_code_to_email(email)

            time.sleep(2)
            code_from_email = get_code_from_email(email)

            verify_user(email, code_from_email)

            complete_referral(fake_user_id, fake_user_secret_token, email, referrer_id)
    return


if __name__ == "__main__":
    user_email = input('email: ')
    user_password = input('password: ')
    refs_count = int(input('сколько тебе накрутить рефералок? '))

    main(user_email, user_password, refs_count)
